Quick Look at the Arch Based Indie Linux Distribution: MagpieOS
======
Most of the Linux distros that are in use today are either created and developed in the US or Europe. A young developer from Bangladesh wants to change all that.

### Who is Rizwan?

[Rizwan][1] is a computer science student from Bangladesh. He is currently studying to become a profession Python programmer. He started using Linux back in 2015. Working with Linux inspired him to create this own Linux distribution. He also wants to let the rest of the world know that Bangladesh is upgrading to Linux.

He has also worked on creating a [live version of Linux From Scratch][2].

## ![MagpieOS Linux][3]

### What is MagpieOS?

Rizwan's new distro is named MagpieOS. [MagpieOS][4] is very simple. It is basically Arch with the GNOME3 desktop environment. MagpieOS also includes a custom repo with icons and themes (claimed to be) not available on other Arch-based distros or AUR.

Here is a list of the software included with MagpieOS: Firefox, LibreOffice, Uget, Bleachbit, Notepadqq, SUSE Studio Image Writer, Pamac Package Manager, Gparted, Gimp, Rhythmbox, Simple Screen Recorder, all default GNOME software including Totem Video Player, and a new set of custom wallpaper.

Currently, MagpieOS only supported the GNOME desktop environment. Rizwan picked it because it is his favorite. However, he plans to add more desktop environments in the future.

Unfortunately, MagpieOS does not support the Bangla language or any other local languages. It supports GNOME's default language like English, Hindi etc.

Rizwan named his distro MagpieOS because the [magpie][5] is the official bird of Bangladesh.

## ![MagpieOS Linux][6]

### Why Arch?

Like most people, Rizwan started his Linux journey by using [Ubuntu][7]. In the beginning, he was happy with it. However, sometimes the software he wanted to install was not available in the repos and he had to hunt through Google looking for the correct PPA. He decided to switch to [Arch][8] because Arch has many packages that were not available on Ubuntu. Rizwan also liked the fact that Arch is a rolling release and would always be up-to-date.

The problem with Arch is that it is complicated and time-consuming to install. So, Rizwan tried out several Arch-based distros and was not happy with any of them. He didn't like [Manjaro][9] because they did not have permission to use Arch's repos. Also, Arch repo mirrors are faster than Manjaro's and have more software. He liked [Antergos][10], but to install you need a constant internet connection. If your connection fails during installation, you have to start over.

Because of these issues, Rizwan decided to create a simple distro that would give him and others an Arch install without all the hassle. He also hopes to get developers from his home country to switch from Ubuntu to Arch by using his distro.

### How to Help Rizwan with MagpieOS

If you are interested in helping Rizwan develop MagpieOS, you can contact him via the [MagpieOS website][4]. You can also check out the project's [GitHub page][11]. Rizwan said that he is not looking for financial support at the moment.

## ![MagpieOS Linux][12]

### Final Thoughts

I installed MagpieOS to give it a quick once-over. It uses the [Calamares installer][13], which means installing it was relatively quick and painless. After I rebooted, I was greeted by an audio message welcoming me to MagpieOS.

To be honest, it was the first time I have heard a post-install greeting. (Windows 10 might have one, but I'm not sure.) There was also a Mac OS-esque application dock at the bottom of the screen. Other than that, it felt like any other GNOME 3 desktop I have used.

Considering that it's an indie project at the nascent stage, I won't recommend it using as your main OS. But if you are a distrohopper, you can surely give it a try.

That being said, this is a good first try for a student seeking to put his country on the technological map. All the best, Rizwan.

Have you already heard of MagpieOS? What is your favorite region or locally made Linux distro? Please let us know in the comments below.

If you found this article interesting, please take a minute to share it on social media.

--------------------------------------------------------------------------------

via: https://itsfoss.com/magpieos/

作者：[John Paul][a]
译者：[译者ID](https://github.com/译者ID)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]: https://itsfoss.com/author/john/
[1]:https://twitter.com/Linux_Saikat
[2]:https://itsfoss.com/linux-from-scratch-live-cd/
[3]:https://itsfoss.com/wp-content/uploads/2018/01/magpieos1.jpg
[4]:http://www.magpieos.net
[5]:https://en.wikipedia.org/wiki/Magpie
[6]:https://itsfoss.com/wp-content/uploads/2018/01/magpieos2.jpg
[7]:https://www.ubuntu.com
[8]:https://www.archlinux.org
[9]:http://manjaro.org
[10]:https://antergos.com
[11]:https://github.com/Rizwan-Hasan/MagpieOS
[12]:https://itsfoss.com/wp-content/uploads/2018/01/magpieos3.png
[13]:https://calamares.io
